<script type="text/javascript" src="/external/lunr/lunr.min.js"></script>

<script type="text/javascript">
(function() {
    'use strict';

    function displayResults (results, data) {
        const searchResults = document.getElementById('results')
        if (results.length !== 0) {
            let resultList = ''
            // Iterate and build result list elements
            for (const n in results) {
                const item = results[n][0];
                
                if (item.showcase !== undefined){
                    var showcase = "<img src='" + item.href + item.showcase + "' alt='Default showcase' class='img-showcase'>";
                }
                else{
                    var showcase = "<img src='/default.webp' alt='Default showcase' class='img-showcase'>";
                    }
                var preview = '';

                if (item.preview !== undefined){
                    preview = "<img src='" + item.href + item.preview + "' alt='Preview of the subject' class='img-prev'>";
                }

                var liContent = '<div class="article-item-title"><h2>' + item.title + '</h2></div>';
                var liTag = '<li class="article-item" onclick=location.href="'+ item.href + '">';

{{ if not .Site.Params.Style.hideTags }}
                if (item.tags !== undefined) {

                    if (item.score !== undefined){
                        liContent += '<div class="grid-tags-score">';
                    }

                    liContent += '<div class="tag-list">';
                    for (const tag in item.tags) {
                        var tagname = item.tags[tag];
                        // This line reproduce the behavior of the urlize hugo
                        // function (see https://github.com/gohugoio/hugo/blob/master/resources/page/permalinks_test.go#L56)
                        var tagclass = tagname.toLowerCase().replace(/ /g, '-');
                        liContent += '<a class="tag-item ' + tagclass + '" href="/tags/' +
                            tagclass +'">' +
                            '<div class="tag-item-tooltip">' + tagname + '</div>' + 
                            '<span><img src="/icon/' + tagname + '.png" onerror="this.style.display=none" alt=' + tagname + '></span>' +
                            '</a>';
                    }

                    liContent += '</div>';

                    if (item.score !== undefined){

                        liContent += '<div class="score">';
                        
                        liContent += '<p>' + item.score + '</p>';

                        liContent += '<div class="score-icon"><div class="score-tooltip">C' + "'" + 'est&nbsp;la&nbsp;difficulté&nbsp;!</div><div class="score-tooltip">Prolopoints</div>' + 
                        '<span><img src="/icon/prolopoint.png"></span></div>';

                        liContent += '</div>';
                    }


                    if (item.score !== undefined){
                        liContent += '</div>';
                    }
                }
{{ end }}

                var liDescription = '<div class="article-item-description"><p>' + item.description + '</p></div>';


                resultList += liTag + showcase + preview + liContent + liDescription + '</li>'
            }
            searchResults.innerHTML = resultList
        } else {
            searchResults.innerHTML = 'Aucun résultat trouvé.'
        }
    }

    // Get the query parameter(s)
    const params = new URLSearchParams(window.location.search)
    const query = params.get('query')

    // Perform a search if there is a query
    if (query) {
        // Retain the search input in the form when displaying results
        document.getElementById('search-input').setAttribute('value', query)
        var results = [];
        var pagesData;

        $.getJSON("/js/lunr/PagesIndex.json").done((data) => {
            pagesData = data;

            const idx = lunr(function() {
                this.field("title", {
                    boost: 10
                });
                this.field("tags", {
                    boost: 5
                });
                this.field("content");

                this.ref("href");

                this.field("showcase");

                this.field("preview");

                this.field("description");

                this.field("score");

                for (const page in pagesData) {
                    if (data[page] !== null)
                        this.add(data[page]);
                }
            });

            results = idx.search(query).map(function (result) {
                return pagesData.filter(function (page) {
                    if (page !== null)
                        return page.href === result.ref;
                })
            });
            displayResults(results, pagesData);
            setupColors();
        });
    }
})();
</script>
